
  PROGRAM

  MAP
    Scroller(*FILE File,*_PROC UpdateProc)
    Updater()
  END

  INCLUDE('KEYCODES.CLW')


ExampleFile FILE,DRIVER('TOPSPEED'),NAME('CLASSES.TPS'),THREAD
              RECORD
Room            STRING(8)
Course          STRING(40)
Instructor      STRING(20)
Contact         STRING(10)
              END
            END

  CODE
    Scroller(ExampleFile,Updater)



!--- Scroller -----------------------------------------------------------------

Scroller PROCEDURE(*FILE File,*_PROC UpdateProc)

  MAP
    Scroller()
  END

Record &GROUP,AUTO

  CODE
    OPEN(File,40H)  ! Read only, deny none
    IF ~ERRORCODE()
      Record &= File{PROP:Record}
      Scroller()
      CLOSE(File)
    ELSE
      MESSAGE(ERROR(),File{PROP:Name})
    END


Scroller PROCEDURE

Window WINDOW('File Scroller'),AT(,,320,190),ALRT(CtrlN),WALLPAPER('WIZABT01.GIF'),TILED,TIMER(5),SYSTEM,RESIZE
         TOOLBAR,AT(0,0,,11),USE(?Toolbar)
         END
       END

DLU:Height EQUATE(10)           ! Approx character height (in DLUs)
DLU:Width  EQUATE(4)            ! Approx character width (in DLUs)

Columns    QUEUE
Header       SIGNED             ! Feq of column header (this goes in the TOOLBAR)
Image1       SIGNED             ! Feq of IMAGE for page 1
Image2       SIGNED             ! Feq of IMAGE for page 2
           END

Scroller   CLASS
Height       UNSIGNED           ! Height of image controls (in pixels)
Items        UNSIGNED           ! Number of rows we can fit in a 'page'
Pos1         SIGNED             ! YPos of Image1 (in pixels)
Pos2         SIGNED             ! YPos of Image2 (in pixels)

Init         PROCEDURE
Reset        PROCEDURE          ! Reset everything (in case the window size changes)
Reset        PROCEDURE(*? Feq)  ! Resets a page for Columns.Image1 or Columns.Image2
OnTimer      PROCEDURE
           END

  CODE
    OPEN(Window)
    Scroller.Init()
    ACCEPT
      CASE EVENT()
      OF EVENT:AlertKey
        START(UpdateProc)       ! You'll need a KEYCODE check here if you ALRT other keys
      OF EVENT:Sized
        Scroller.Reset()
      OF EVENT:Timer
        Scroller.OnTimer()
      END
    END
    CLOSE(Window)


Scroller.Init PROCEDURE

  MAP
    CreateImage(*SIGNED Feq)
  END

I UNSIGNED,AUTO
W UNSIGNED,AUTO
X UNSIGNED(0)

  CODE
    Window{PROP:Buffer} = TRUE
    Window{PROP:Imm} = TRUE     ! Setting here avoids generation of EVENT:Sized when the window opens
    Window{PROP:Pixels} = FALSE
    LOOP I = 1 TO File{PROP:Fields}
      W = File{PROP:Size,I} * DLU:Width
      DO CreateHeader
      CreateImage(Columns.Image1)
      CreateImage(Columns.Image2)
      ADD(Columns)
?     ASSERT(~ERRORCODE(),ERROR())
      X += W
    END
    Window{PROP:Pixels} = TRUE
    SYSTEM{PROP:DeferMove} = -(RECORDS(Columns) * 2)
    SELF.Reset()

CreateHeader ROUTINE
  Columns.Header = CREATE(0,CREATE:Prompt,?Toolbar)
? ASSERT(Columns.Header)
  Columns.Header{PROP:Text} = File{PROP:Label,I}
  SETPOSITION(Columns.Header,X,1,W)
  UNHIDE(Columns.Header)

CreateImage PROCEDURE(*SIGNED Feq)
  CODE
    Feq = CREATE(0,CREATE:Image)
?   ASSERT(Feq)
    SETPOSITION(Feq,X,0,W)
    UNHIDE(Feq)


Scroller.Reset PROCEDURE
  CODE
    SET(File)
    Window{PROP:Pixels} = FALSE
    SELF.Items = (Window{PROP:ClientHeight} / DLU:Height) + 1
    GET(Columns,1)
    LOOP WHILE ~ERRORCODE()
      SETPOSITION(Columns.Image1,,0,,SELF.Items * DLU:Height)
      SETPOSITION(Columns.Image2,,Columns.Image1{PROP:Height},,Columns.Image1{PROP:Height})
      GET(Columns,POINTER(Columns)+1)
    END
    Window{PROP:Pixels} = TRUE
    SELF.Height = Columns.Image1{PROP:Height}
    SELF.Pos1 = Columns.Image1{PROP:YPos}
    SELF.Pos2 = Columns.Image2{PROP:YPos}
    SELF.Reset(Columns.Image1)
    SELF.Reset(Columns.Image2)


Scroller.Reset PROCEDURE(*? Feq)
Items UNSIGNED,AUTO
  CODE
    Window{PROP:Pixels} = FALSE
    DO Blank
    STREAM(File)
    LOOP Items = 0 TO SELF.Items-1
      LOOP 2 TIMES
        NEXT(File)
        IF ~ERRORCODE()
          BREAK
        ELSE
          SET(File)
          CLEAR(File)
        END
      END
      DO Show
    END
    FLUSH(File)
    Window{PROP:Pixels} = TRUE

Blank ROUTINE
  GET(Columns,1)
  LOOP WHILE ~ERRORCODE()
    SETTARGET(Window,Feq)
    BLANK()
    SETTARGET()
    GET(Columns,POINTER(Columns)+1)
  END

Show ROUTINE
  GET(Columns,1)
  LOOP WHILE ~ERRORCODE()
    SETTARGET(Window,Feq)
    SHOW(0,Items * DLU:Height,WHAT(Record,POINTER(Columns)))
    SETTARGET()
    GET(Columns,POINTER(Columns)+1)
  END


Scroller.OnTimer PROCEDURE
  CODE
    IF SELF.Pos1 + SELF.Height = 0
      SELF.Reset(Columns.Image1)
      SELF.Pos1 = SELF.Height
    ELSIF SELF.Pos2 + SELF.Height = 0
      SELF.Reset(Columns.Image2)
      SELF.Pos2 = SELF.Height
    ELSE
      SELF.Pos1 -= 1
      SELF.Pos2 -= 1
    END
    GET(Columns,1)
    LOOP WHILE ~ERRORCODE()
      Columns.Image1{PROP:YPos} = SELF.Pos1
      Columns.Image2{PROP:YPos} = SELF.Pos2
      GET(Columns,POINTER(Columns)+1)
    END



!--- Updater ------------------------------------------------------------------

Updater PROCEDURE
  CODE
    SHARE(ExampleFile)
    IF ~ERRORCODE()
      CLEAR(ExampleFile)
      DO Updater
      CLOSE(ExampleFile)
    ELSE
      MESSAGE(ERROR(),'Open Failed')
    END

Updater ROUTINE
  DATA
W WINDOW('Insert'),AT(,,200,100),CENTER,GRAY
    PROMPT('Room:'),AT(5,6)
    ENTRY(@s8),AT(70,6,125,10),USE(ExampleFile.Room)
    PROMPT('Course:'),AT(5,22)
    ENTRY(@s40),AT(70,22,125,10),USE(ExampleFile.Course)
    PROMPT('Instructor:'),AT(5,37)
    ENTRY(@s20),AT(70,37,125,10),USE(ExampleFile.Instructor)
    PROMPT('Contact:'),AT(5,53)
    ENTRY(@s10),AT(70,53,125,10),USE(ExampleFile.Contact)
    BUTTON('OK'),AT(48,80,50,14),USE(?Button:OK),DEFAULT
    BUTTON('Cancel'),AT(103,80,50,14),STD(STD:Close)
  END
  CODE
    OPEN(W)
    ACCEPT
      IF ACCEPTED() = ?Button:OK
        ADD(ExampleFile)
        IF ~ERRORCODE()
          BREAK
        ELSE
          MESSAGE(ERROR(),'Insert Failed')
        END
      END
    END
    CLOSE(W)
